/*
 * @(#)Counter.java	1.30 97/03/03
 *
 * Copyright (c) 1995-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * CopyrightVersion 1.0
 */
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

import sun.server.http.Cookie;

/* Simple servlet to test the api.
 * @author  Pavani Diwanji
 */
public
class Counter extends HttpServlet {
    private int count = 0;

    public void init(ServletConfig cnf) throws ServletException {
	super.init(cnf);
	String s = getInitParameter("initial");
	count = (s == null ? 0 : Integer.parseInt(s));
    }

    public void service(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException
    {
	// printClientCookies(req);

	Cookie cookies[] = new Cookie[2];
	long tm = System.currentTimeMillis();
	cookies[0] = new Cookie("a", "aa");
	cookies[1] = new Cookie("b", "bb");
	cookies[0].setExpires(tm + 600000);
	cookies[0].setPath("/counter.html");
	cookies[1].setPath("/");
	res.setHeader("Set-Cookie", Cookie.toString(cookies));

	count++;
	String hellostr = null;
	String countstr = "count=" + count;
	res.setContentType("text/html");
	res.setContentLength(countstr.length()+1); // +1 for \n
	PrintStream out = new PrintStream(res.getOutputStream());
	out.println(countstr);
    }

    public void printClientCookies(HttpServletRequest req) {
	String s = req.getHeader("Cookie");
	if (s != null) {
	    Cookie cookie = new Cookie(s);
	    String c[] = cookie.getCookieNames();
	    System.out.print("Cookies In: ");
	    for (int i=0; i<c.length; ++i)
		System.out.print(c[i] + " ");
	    System.out.println();
	}
    }

    public String getServletInfo() {
	return "This counter servlet is present as an example and a simple test.";
    }
}
