/*
 *
 * See attached license Agreement.
 *
 * IBM MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. IBM SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 *
 */

import java.io.IOException;
import javax.servlet.*;
import javax.servlet.http.*;

public class HelloCGIServlet extends HttpServlet
{
    // START_OF_COPYRIGHT
    // (do not edit this message, as it is generated automatically)
    public static String copyright="(C) Copyright IBM Corp. 1996, 1997, All rights reserved.";
    // END_OF_COPYRIGHT


    public void service(HttpServletRequest req, HttpServletResponse res) throws ServletException
    {
        try
        {
    	    res.setContentType("text/html");
        	ServletOutputStream out = res.getOutputStream();

    	    out.println("<html>");
    	    out.println("<head><title> Hello CGI </title></head>");
        	out.println("<body BGCOLOR=\"#FFFFFF\">");
	        out.println("<h1>See how you can get your CGI parameters </h1>");

            putStartTable(out);
            putCaption(" How to get the cgi vars ? ", out);

            putHeaderRow("CGI Var Name",    "Current Value",            "Method to be used", out);

            putDataRow("REQUEST_METHOD",    req.getMethod(),            "req.getMethod()", out);
            putDataRow("REQUEST_URI",       req.getRequestURI(),        "req.getRequestURI()", out);
            putDataRow("CONTENT_LENGTH",    String.valueOf(req.getContentLength()), "req.getContentLength()", out);
            putDataRow("CONTENT_TYPE",      req.getContentType(),       "req.getContentType()", out);
            putDataRow("SERVER_PROTOCOL",   req.getProtocol(),          "req.getProtocol()", out);
            putDataRow("SERVER_NAME",       req.getServerName(),        "req.getServerName()", out);
            putDataRow("SERVER_PORT",       String.valueOf(req.getServerPort()), "req.getServerPort()", out);
            putDataRow("REMOTE_ADDR",       req.getRemoteAddr(),        "req.getRemoteAddr()", out);
            putDataRow("REMOTE_HOST",       req.getRemoteHost(),        "req.getRemoteHost()", out);
            putDataRow("SCRIPT_NAME",       req.getServletPath(),       "req.getServletPath()", out);
            putDataRow("PATH_INFO",         req.getPathInfo(),          "req.getPathInfo()", out);
            putDataRow("QUERY_STRING",      req.getQueryString(),       "req.getQueryString()", out);
            putDataRow("REMOTE_USER",       req.getRemoteUser(),        "req.getRemoteUser()", out);
            putDataRow("AUTH_TYPE",         req.getAuthType(),          "req.getAuthType()", out);
            putDataRow("PATH_TRANSLATED",   req.getPathTranslated(),    "req.getPathTranslated()", out);

            putEndTable(out);


	        out.println("</body></html>");
	    }
	    catch(IOException ioe)
	    {
	        ioe.printStackTrace();
	    }
    }

    protected void putHeaderRow(String h1, String h2, String h3, ServletOutputStream out) throws IOException
    {
        putStartRow(out);
        putHeaderCell(h1, out);
        putHeaderCell(h2, out);
        putHeaderCell(h3, out);
        putEndRow(out);
    }

    protected void putDataRow(String d1, String d2, String d3, ServletOutputStream out) throws IOException
    {
        putStartRow(out);
        putDataCell(d1, out);
        putDataCell(d2, out);
        putDataCell(d3, out);
        putEndRow(out);
    }

    protected void putCaption(String caption, ServletOutputStream out) throws IOException
    {
        out.println("<caption> " + nullToEmpty(caption) + " </caption>");
    }

    protected void putDataCell(String data, ServletOutputStream out) throws IOException
    {
        out.println("<td> " + nullToEmpty(data) + " </td>");
    }

    protected void putHeaderCell(String header, ServletOutputStream out) throws IOException
    {
        out.println("<th> " + nullToEmpty(header) + " </th>");
    }

    protected void putStartRow(ServletOutputStream out) throws IOException
    {
        out.println("<tr>");
    }

    protected void putEndRow(ServletOutputStream out) throws IOException
    {
        out.println("</tr>");
    }

    protected void putStartTable(ServletOutputStream out) throws IOException
    {
        out.println("<table border=3>");
    }

    protected void putEndTable(ServletOutputStream out) throws IOException
    {
        out.println("</table>");
    }

    protected String nullToEmpty(String str) throws IOException
    {
        if(null == str)
        {
            return "Not available";
        }
        return str;
    }

    public String getServletInfo()
    {
	    return "Create a page that shows the cgi parameters.";
    }

    public void destroy()
    {
	    System.out.println("In destroy ...");
    }
}