/*
 *
 * See attached license Agreement.
 *
 * IBM MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. IBM SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 *
 */

/*
 * This is a very simple demo to show how to use the Servlet Side Include
 * options in ServletExpress.
 */

import java.io.IOException;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;

import java.util.Enumeration;

import com.ibm.ServletExpress.stubs.NativeWriter;
import com.ibm.ServletExpress.stubs.NativeResponse;
import com.ibm.ServletExpress.util.MimeHeaderPack;


class Stub implements NativeResponse, NativeWriter
{
    HttpServletRequest  m_req;
    HttpServletResponse m_res;
    ServletOutputStream m_out;
    boolean             m_okRc;

    public Stub(HttpServletRequest req, HttpServletResponse res)
    {
        try
        {
            m_req = req;
            m_res = res;
            m_okRc = true;

            m_res.setContentType("text/html");
            m_out = m_res.getOutputStream();

            m_out.println("<html><body>");

        }
        catch(IOException io)
        {
        }
    }

    public void setStatuseLine(int sc, String smString)
    {
        try
        {
            m_out.println("<p> Status line is " + sc + " " + smString);
        }
        catch(IOException io)
        {
        }
    }

    /*
     * In order to save the headers for later you should clone the
     * mime headers
     */
    public void setOutputMime(MimeHeaderPack outHeaders)
    {
        try
        {
            m_out.println("<p> Mime headers are :");
            for(Enumeration e = outHeaders.enumHeaderNames() ; e.hasMoreElements() ;)
            {
                String name = (String)e.nextElement();
                String value = outHeaders.getHeader(name);
                m_out.println("<p> " + name + " = " + value);
            }
        }
        catch(IOException io)
        {
        }
    }

    public int write(byte []b, int from, int len) throws IOException
    {
        if(m_okRc)
        {
            m_out.println("<p> Write string <p>");
            m_out.write(b, from, len);
        }

        return len;
    }

    public void closeWriter() throws IOException
    {
        m_out.println("</html></body>");
        m_out.flush();
    }
}

public class SSinvServletDemo extends com.ibm.ServletExpress.core.SSinvServlet
{
    public void service(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
        Stub s = new Stub(req, res);

        String [] empty = new String[0];

        /*
         * Input is:
         *
         * 1. NativeResponse interface.
         * 2. NativeWriter interface.
         * 3. request.
         * 4. response.
         * 5. code of the servlet (e.g in DateServlet.class it is DateServlet).
         * 6. codebase (unused).
         * 7. Init Parameters Names - An array with init parameter names.
         * 8. Init Parameters Values - An array with init parameter values.
         * 9. Archives - An array with the archives of the servlets.
         * 10. Extra Parameters Names - An array with extra parameters names.
         * 11. Extra Parameters Values -  An array with extra parameter values.
         *
         */
        ssincludeInvoke((NativeResponse)s,
                                      (NativeWriter)s,
                                       req,
                                       res,
                                       "DateServlet",
                                       "",
                                       empty,
                                       empty,
                                       empty,
                                       empty,
                                       empty);
    }
}
