/*
 *
 * See attached license Agreement.
 *
 * IBM MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. IBM SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 *
 */

/*
 * This is a very simple demo to show how to use the invoker
 * options in ServletExpress.
 */

import java.io.IOException;
import javax.servlet.*;
import javax.servlet.http.*;

public class ServletInvokerDemo extends com.ibm.ServletExpress.core.ServletInvoker
{
    // START_OF_COPYRIGHT
    // (do not edit this message, as it is generated automatically)
    public static String copyright="(C) Copyright IBM Corp. 1996, 1997, All rights reserved.";
    // END_OF_COPYRIGHT

    public void service(HttpServletRequest req, HttpServletResponse res) throws ServletException
    {
        try
        {
            String pathInfo = req.getPathInfo();
            String servletName = null;
            StringBuffer sb = new StringBuffer();
            int i;

            for(i = 0 ; (i < pathInfo.length()) && (pathInfo.charAt(i) == '/') ; i++)
                ;
            for(; i < pathInfo.length(); i++)
            {
                sb.append(pathInfo.charAt(i));
            }
            servletName = sb.toString();

            /*
             * Input is
             * 1. name of servlet.
             * 2. path info.
             * 3. request.
             * 4. response.
             */
            if(false == invokeServletByName(servletName,
                                            req.getServletPath() + pathInfo,
                                            req,
                                            res))
            {
        	    res.setContentType("text/html");
            	ServletOutputStream out = res.getOutputStream();

    	        out.println("<html>");
    	        out.println("<head><title> Invokation Error </title></head>");
    	        out.println("<body BGCOLOR=\"#FFFFFF\">");
	            out.println("<h1> Invokation Error </h1>");
      	        out.println("</body></html>");
      	        out.flush();
    	    }
	    }
	    catch(IOException ioe)
	    {
	        ioe.printStackTrace();
	    }
    }
}